import { Injectable } from '@angular/core';
import {
  ActivatedRouteSnapshot,
  Resolve,
  Router,
  RouterStateSnapshot,
} from '@angular/router';
import { BankService } from 'app/modules/polyglot/bank/services/bank.service';
import { MemberClassService } from 'app/modules/polyglot/member_class/services/member_class.service';
import {
  ListBanksRequest,
  ListBanksResponse,
} from 'app/modules/proto/c2se/bank_pb';
import {
  ListMemberClassesRequest,
  ListMemberClassesResponse,
} from 'app/modules/proto/c2se/member_class_pb';

import { Observable } from 'rxjs';

@Injectable({
  providedIn: 'root',
})
export class ListMemberBanksResolver implements Resolve<any> {
  /**
   * Constructor
   */
  constructor(private _router: Router, private __bankService: BankService) {}

  // -----------------------------------------------------------------------------------------------------
  // @ Public methods
  // -----------------------------------------------------------------------------------------------------

  /**
   * Resolver
   *
   * @param route
   * @param state
   */

  resolve(
    route: ActivatedRouteSnapshot,
    state: RouterStateSnapshot
  ):
    | Observable<ListBanksResponse.Result>
    | Promise<ListBanksResponse.Result>
    | ListBanksResponse.Result {
    return this.__bankService.listBanks();
  }
}
